TradeView = Subview:extend {
   drawParent = true, --default?
   onNew = function (self)
              -- create all the interface bits from the planet
              -- and add them to the view

              local boxL = the.app.width / 2 - 200
              local boxT = the.app.height / 2 - 200
              local boxR = boxL + 400

              local lh = 17 -- line height

              self:add(Fill:new{
                          fill = {255,255,255},
                          x = boxL - 1,
                          y = boxT - 1,
                          width = 402,
                          height = 402,
                       })

              self:add(Fill:new{
                          fill = {0,0,0},
                          x = boxL,
                          y = boxT,
                          width = 400,
                          height = 400,
                       })

              for i, good in ipairs(self.planet.goods) do
                 local t = Text:new{
                    text = good[1],
                    x = boxL + 10,
                    y = boxT + 10 + (i-1) * lh,
                    width = 380
                 }

                 self:add(t)

                 t = Text:new{
                    text = good[2],
                    x = boxL + 10,
                    y = boxT + 10 + (i-1) * lh,
                    width = 300,
                    align = 'right'
                 }
                 self:add(t)

                 local b = Button:new{
                    x = boxR - 80,
                    y = boxT + 10 + (i-1) * lh - 1,
                    label = Text:new{ text = 'BUY', x = 1 },
                 }
                 local tw, th = b.label:getSize()
                 b.background = Fill:new{
                    fill = {100,100,100},
                    width = tw + 3,
                    height = th
                 }
                 self:add(b)

                 b = Button:new{
                    x = boxR - 40,
                    y = boxT + 10 + (i-1) * lh - 1,
                    label = Text:new{ text = 'SELL', x = 1 },
                 }
                 local tw, th = b.label:getSize()
                 b.background = Fill:new{
                    fill = {100,100,100},
                    width = tw + 3,
                    height = th
                 }
                 self:add(b)

              end
           end,
   activate = function (self)
                 the.cursor.visible = false
                 love.mouse.setVisible(true)
                 love.mouse.setGrab(false)

                 Subview.activate(self)
              end,

}